Index: include/asterisk/frame.h
===================================================================
--- include/asterisk/frame.h	(revision 258188)
+++ include/asterisk/frame.h	(working copy)
@@ -717,6 +717,7 @@
 static force_inline int ast_format_rate(format_t format)
 {
 	switch (format) {
+	case AST_FORMAT_SPEEX:
 	case AST_FORMAT_G722:
 	case AST_FORMAT_SLINEAR16:
 	case AST_FORMAT_SIREN7:
Index: main/frame.c
===================================================================
--- main/frame.c	(revision 258188)
+++ main/frame.c	(working copy)
@@ -1407,7 +1407,7 @@
 		bit += off;
 
 		if ((len * 8 - bit) < 5) {
-			ast_log(LOG_WARNING, "Not enough bits remaining after wide band for speex samples.\n");
+		//	ast_log(LOG_WARNING, "Not enough bits remaining after wide band for speex samples.\n");
 			break;
 		}
 
Index: main/stun.c
===================================================================
--- main/stun.c	(revision 258188)
+++ main/stun.c	(working copy)
@@ -41,7 +41,7 @@
 #include <openssl/hmac.h>
 #endif
 
-static int stundebug = 1;			/*!< Are we debugging stun? */
+static int stundebug = 0;			/*!< Are we debugging stun? */
 
 /*!
  * \brief STUN support code
Index: codecs/codec_speex.c
===================================================================
--- codecs/codec_speex.c	(revision 258188)
+++ codecs/codec_speex.c	(working copy)
@@ -102,7 +102,7 @@
 {
 	struct speex_coder_pvt *tmp = pvt->pvt;
 
-	if (!(tmp->speex = speex_encoder_init(&speex_nb_mode)))
+	if (!(tmp->speex = speex_encoder_init(&speex_wb_mode)))
 		return -1;
 
 	speex_bits_init(&tmp->bits);
@@ -111,7 +111,7 @@
 	speex_encoder_ctl(tmp->speex, SPEEX_SET_COMPLEXITY, &complexity);
 #ifdef _SPEEX_TYPES_H
 	if (preproc) {
-		tmp->pp = speex_preprocess_state_init(tmp->framesize, 8000); /* XXX what is this 8000 ? */
+		tmp->pp = speex_preprocess_state_init(tmp->framesize, 16000); /* XXX what is this 16000 ? */
 		speex_preprocess_ctl(tmp->pp, SPEEX_PREPROCESS_SET_VAD, &pp_vad);
 		speex_preprocess_ctl(tmp->pp, SPEEX_PREPROCESS_SET_AGC, &pp_agc);
 		speex_preprocess_ctl(tmp->pp, SPEEX_PREPROCESS_SET_AGC_LEVEL, &pp_agc_level);
@@ -325,13 +325,13 @@
 
 static struct ast_translator lintospeex = {
 	.name = "lintospeex", 
-	.srcfmt = AST_FORMAT_SLINEAR,
+	.srcfmt = AST_FORMAT_SLINEAR16,
 	.dstfmt = AST_FORMAT_SPEEX,
 	.newpvt = lintospeex_new,
 	.framein = lintospeex_framein,
 	.frameout = lintospeex_frameout,
 	.destroy = lintospeex_destroy,
-	.sample = slin8_sample,
+	.sample = slin16_sample,
 	.desc_size = sizeof(struct speex_coder_pvt),
 	.buffer_samples = BUFFER_SAMPLES,
 	.buf_size = BUFFER_SAMPLES * 2, /* XXX maybe a lot less ? */
